/*
 * generated by Xtext 2.27.0
 */
package tdt4250.ra.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;
import tdt4250.ra.ide.contentassist.antlr.internal.InternalRaDSL2022Parser;
import tdt4250.ra.services.RaDSL2022GrammarAccess;

public class RaDSL2022Parser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(RaDSL2022GrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, RaDSL2022GrammarAccess grammarAccess) {
			builder.put(grammarAccess.getEStringAccess().getAlternatives(), "rule__EString__Alternatives");
			builder.put(grammarAccess.getEFloatAccess().getAlternatives_4_0(), "rule__EFloat__Alternatives_4_0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup(), "rule__Department__Group__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_4(), "rule__Department__Group_4__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_5(), "rule__Department__Group_5__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_5_3(), "rule__Department__Group_5_3__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_6(), "rule__Department__Group_6__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_6_3(), "rule__Department__Group_6_3__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_7(), "rule__Department__Group_7__0");
			builder.put(grammarAccess.getDepartmentAccess().getGroup_7_3(), "rule__Department__Group_7_3__0");
			builder.put(grammarAccess.getPersonAccess().getGroup(), "rule__Person__Group__0");
			builder.put(grammarAccess.getCourseAccess().getGroup(), "rule__Course__Group__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_4_0(), "rule__Course__Group_4_0__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_4_1(), "rule__Course__Group_4_1__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_4_1_3(), "rule__Course__Group_4_1_3__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup(), "rule__ResourceAllocation__Group__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup_3(), "rule__ResourceAllocation__Group_3__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup_4(), "rule__ResourceAllocation__Group_4__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup_5(), "rule__ResourceAllocation__Group_5__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup_6(), "rule__ResourceAllocation__Group_6__0");
			builder.put(grammarAccess.getRoleAccess().getGroup(), "rule__Role__Group__0");
			builder.put(grammarAccess.getRoleAccess().getGroup_4(), "rule__Role__Group_4__0");
			builder.put(grammarAccess.getEFloatAccess().getGroup(), "rule__EFloat__Group__0");
			builder.put(grammarAccess.getEFloatAccess().getGroup_4(), "rule__EFloat__Group_4__0");
			builder.put(grammarAccess.getDepartmentAccess().getNameAssignment_2(), "rule__Department__NameAssignment_2");
			builder.put(grammarAccess.getDepartmentAccess().getShortNameAssignment_4_1(), "rule__Department__ShortNameAssignment_4_1");
			builder.put(grammarAccess.getDepartmentAccess().getStaffAssignment_5_2(), "rule__Department__StaffAssignment_5_2");
			builder.put(grammarAccess.getDepartmentAccess().getStaffAssignment_5_3_1(), "rule__Department__StaffAssignment_5_3_1");
			builder.put(grammarAccess.getDepartmentAccess().getCoursesAssignment_6_2(), "rule__Department__CoursesAssignment_6_2");
			builder.put(grammarAccess.getDepartmentAccess().getCoursesAssignment_6_3_1(), "rule__Department__CoursesAssignment_6_3_1");
			builder.put(grammarAccess.getDepartmentAccess().getResourceAllocationsAssignment_7_2(), "rule__Department__ResourceAllocationsAssignment_7_2");
			builder.put(grammarAccess.getDepartmentAccess().getResourceAllocationsAssignment_7_3_1(), "rule__Department__ResourceAllocationsAssignment_7_3_1");
			builder.put(grammarAccess.getPersonAccess().getNameAssignment_2(), "rule__Person__NameAssignment_2");
			builder.put(grammarAccess.getCourseAccess().getNameAssignment_2(), "rule__Course__NameAssignment_2");
			builder.put(grammarAccess.getCourseAccess().getCodeAssignment_4_0_1(), "rule__Course__CodeAssignment_4_0_1");
			builder.put(grammarAccess.getCourseAccess().getRolesAssignment_4_1_2(), "rule__Course__RolesAssignment_4_1_2");
			builder.put(grammarAccess.getCourseAccess().getRolesAssignment_4_1_3_1(), "rule__Course__RolesAssignment_4_1_3_1");
			builder.put(grammarAccess.getResourceAllocationAccess().getFactorAssignment_3_1(), "rule__ResourceAllocation__FactorAssignment_3_1");
			builder.put(grammarAccess.getResourceAllocationAccess().getPersonAssignment_4_1(), "rule__ResourceAllocation__PersonAssignment_4_1");
			builder.put(grammarAccess.getResourceAllocationAccess().getCourseAssignment_5_1(), "rule__ResourceAllocation__CourseAssignment_5_1");
			builder.put(grammarAccess.getResourceAllocationAccess().getRoleAssignment_6_1(), "rule__ResourceAllocation__RoleAssignment_6_1");
			builder.put(grammarAccess.getRoleAccess().getNameAssignment_2(), "rule__Role__NameAssignment_2");
			builder.put(grammarAccess.getRoleAccess().getWorkloadAssignment_4_1(), "rule__Role__WorkloadAssignment_4_1");
			builder.put(grammarAccess.getCourseAccess().getUnorderedGroup_4(), "rule__Course__UnorderedGroup_4");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private RaDSL2022GrammarAccess grammarAccess;

	@Override
	protected InternalRaDSL2022Parser createParser() {
		InternalRaDSL2022Parser result = new InternalRaDSL2022Parser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public RaDSL2022GrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(RaDSL2022GrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
